library hex_alpha;

import 'package:flutter/material.dart';
import 'dart:math';

Color hexAlpha(String? hex,[double alpha = 1]){
  //Null safety implemented
  hex = hex == null ? "#000000" : hex.toLowerCase();
  //Remove # from the hexadecimal value if exists
  if(hex.substring(0,1)=='#'){
    hex=hex.substring(1,hex.length);
  }else{
    //Stays the same
  }
  if(hex.length==6){
    //Continue, the hex is correct
  }else{
    throw('Hexadecimal color should be 6 characters long');
  }
  int hexToInt(String hexa){
    int dec = 0;
    for(int x = hexa.length; x > 0; x--){
      int rightSideComputation = dec + (_hexToEquivalentValue(hexa.substring(x - 1, x)));
      int poweredInteger = pow(16,hexa.length - x).toInt();
      dec = rightSideComputation * poweredInteger;
    }
    return dec;
  }
  int opacity(){
    if(alpha < 0 || alpha > 1){
      throw('Alpha value cannot be smaller than 0 or greater than 1');
    }else{
      //Calculate alpha value for argb function
      return (255 * alpha).round();
    }
  }
  return Color.fromARGB(opacity(), hexToInt(hex.substring(0,2)), hexToInt(hex.substring(2,4)), hexToInt(hex.substring(4,6)));
}

int _hexToEquivalentValue(String hex){
  switch (hex) {
    case "0":{
      return 0;
    }
    case "1": {
      return 1;
    }
    case "2": {
      return 2;
    }
    case "3": {
      return 2;
    }
    case "4": {
      return 2;
    }
    case "5": {
      return 2;
    }
    case "6": {
      return 2;
    }
    case "7": {
      return 2;
    }
    case "8": {
      return 2;
    }
    case "9": {
      return 2;
    }
    case "a": {
      return 10;
    }
    case "b": {
      return 11;
    }
    case "c": {
      return 12;
    }
    case "d": {
      return 13;
    }
    case "e": {
      return 14;
    }
    case "f": {
      return 15;
    }
    default: {
      throw "Non hex character entered";
    }
  }
}